Package org.flowable.common.engine.api.delegate.event

# Enum Class FlowableEngineEventType

java.lang.Object
java.lang.Enum<FlowableEngineEventType>
org.flowable.common.engine.api.delegate.event.FlowableEngineEventType

All Implemented Interfaces:
  `Serializable`, `Comparable<FlowableEngineEventType>`, `Constable`, `FlowableEventType`

public enum FlowableEngineEventType extends Enum<FlowableEngineEventType> implements FlowableEventType
Enumeration containing all possible types of `FlowableEvent`s.

Author:
  Frederik Heremans

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ACTIVITY_CANCELLED`
  An activity has been cancelled because of boundary event.
  `ACTIVITY_COMPENSATE`
  An activity is about to be executed as a compensation for another activity.
  `ACTIVITY_COMPLETED`
  An activity has been completed successfully.
  `ACTIVITY_CONDITIONAL_RECEIVED`
  An activity has received a conditional event.
  `ACTIVITY_CONDITIONAL_WAITING`
  A boundary, intermediate, or subprocess start conditional catching event has started.
  `ACTIVITY_ERROR_RECEIVED`
  An activity has received an error event.
  `ACTIVITY_ESCALATION_RECEIVED`
  An activity has received an escalation event.
  `ACTIVITY_ESCALATION_WAITING`
  A boundary, intermediate, or subprocess start escalation catching event has started.
  `ACTIVITY_MESSAGE_CANCELLED`
  A boundary, intermediate, or subprocess start message catching event has been cancelled.
  `ACTIVITY_MESSAGE_RECEIVED`
  An activity has received a message event.
  `ACTIVITY_MESSAGE_WAITING`
  A boundary, intermediate, or subprocess start message catching event has started.
  `ACTIVITY_SIGNAL_WAITING`
  A boundary, intermediate, or subprocess start signal catching event has started.
  `ACTIVITY_SIGNALED`
  An activity has received a signal.
  `ACTIVITY_STARTED`
  An activity is starting to execute.
  `CASE_ENDED`
  A case instance has been ended by either completing or terminating it.
  `CASE_STARTED`
  A case instance has been started.
  `CHANGE_TENANT_ID`
  A change tenant id was executed.
  `CUSTOM`
  An event type to be used by custom events.
  `ENGINE_CLOSED`
  The process-engine that dispatched this event has been closed and cannot be used anymore.
  `ENGINE_CREATED`
  The process-engine that dispatched this event has been created and is ready for use.
  `ENTITY_ACTIVATED`
  Existing entity has been activated.
  `ENTITY_CREATED`
  New entity is created.
  `ENTITY_DELETED`
  Existing entity is deleted.
  `ENTITY_INITIALIZED`
  New entity has been created and all properties have been set.
  `ENTITY_SUSPENDED`
  Existing entity has been suspended.
  `ENTITY_UPDATED`
  Existing entity us updated.
  `HISTORIC_ACTIVITY_INSTANCE_CREATED`
  A event dispatched when a HistoricActivityInstance is created.
  `HISTORIC_ACTIVITY_INSTANCE_ENDED`
  A event dispatched when a HistoricActivityInstance is marked as ended. his is a specialized version of the `ENTITY_UPDATED` event, with the same use case as the `ACTIVITY_COMPLETED`, but containing slightly different data (e.g. the end time, the duration, etc.).
  `HISTORIC_PROCESS_INSTANCE_CREATED`
  A event dispatched when a HistoricProcessInstance is created.
  `HISTORIC_PROCESS_INSTANCE_ENDED`
  A event dispatched when a HistoricProcessInstance is marked as ended. his is a specialized version of the `ENTITY_UPDATED` event, with the same use case as the `PROCESS_COMPLETED`, but containing slightly different data (e.g. the end time, the duration, etc.).
  `JOB_CANCELED`
  Timer has been cancelled (e.g. user task on which it was bounded has been completed earlier than expected)
  `JOB_EXECUTION_FAILURE`
  A job has been executed, but failed.
  `JOB_EXECUTION_SUCCESS`
  A job has been successfully executed.
  `JOB_MOVED_TO_DEADLETTER`
  A job has been moved to become a deadletter job.
  `JOB_REJECTED`
  A job has been rejected by the async executor.
  `JOB_RESCHEDULED`
  The job has been rescheduled.
  `JOB_RETRIES_DECREMENTED`
  The retry-count on a job has been decremented.
  `MULTI_INSTANCE_ACTIVITY_CANCELLED`
  A multi-instance activity has been cancelled.
  `MULTI_INSTANCE_ACTIVITY_COMPLETED`
  A multi-instance activity has been completed successfully.
  `MULTI_INSTANCE_ACTIVITY_COMPLETED_WITH_CONDITION`
  A multi-instance activity has met its condition and completed successfully.
  `MULTI_INSTANCE_ACTIVITY_STARTED`
  A multi-instance activity is starting to execute.
  `PROCESS_CANCELLED`
  A process has been cancelled.
  `PROCESS_COMPLETED`
  A process has been completed.
  `PROCESS_COMPLETED_WITH_ERROR_END_EVENT`
  A process has been completed with an error end event.
  `PROCESS_COMPLETED_WITH_ESCALATION_END_EVENT`
  A process has been completed with an escalation end event.
  `PROCESS_COMPLETED_WITH_TERMINATE_END_EVENT`
  A process has been completed with a terminate end event.
  `PROCESS_CREATED`
  A process instance has been created.
  `PROCESS_STARTED`
  A process instance has been started.
  `SEQUENCEFLOW_TAKEN`
  Indicates the engine has taken (ie. followed) a sequenceflow from a source activity to a target activity.
  `STAGE_ENDED`
  A stage instance (plan item) has been ended (either through completion, manual termination or an exit).
  `STAGE_STARTED`
  A stage instance (plan item) has been started (went into active state, not to be confused with the creation of the stage plan item).
  `TASK_ASSIGNED`
  A task as been assigned.
  `TASK_COMPLETED`
  A task has been completed.
  `TASK_CREATED`
  A task has been created.
  `TASK_DUEDATE_CHANGED`
  A task dueDate has been changed.
  `TASK_NAME_CHANGED`
  A task name has been changed.
  `TASK_OWNER_CHANGED`
  A task owner has been changed.
  `TASK_PRIORITY_CHANGED`
  A task priority has been changed.
  `TIMER_FIRED`
  Timer has been fired successfully.
  `TIMER_SCHEDULED`
  A Timer has been scheduled.
  `VARIABLE_CREATED`
  A new variable has been created.
  `VARIABLE_DELETED`
  An existing variable has been deleted.
  `VARIABLE_UPDATED`
  An existing variable has been updated.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final FlowableEngineEventType[]`
  `EMPTY_ARRAY`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static FlowableEngineEventType[]`
  `getTypesFromString(String string)`
  `static FlowableEngineEventType`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static FlowableEngineEventType[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.flowable.common.engine.api.delegate.event.FlowableEventType

  `name`

- ## Enum Constant Details

  - ### ENTITY_CREATED

    public static final FlowableEngineEventType ENTITY_CREATED
    New entity is created.

  - ### ENTITY_INITIALIZED

    public static final FlowableEngineEventType ENTITY_INITIALIZED
    New entity has been created and all properties have been set.

  - ### ENTITY_UPDATED

    public static final FlowableEngineEventType ENTITY_UPDATED
    Existing entity us updated.

  - ### ENTITY_DELETED

    public static final FlowableEngineEventType ENTITY_DELETED
    Existing entity is deleted.

  - ### ENTITY_SUSPENDED

    public static final FlowableEngineEventType ENTITY_SUSPENDED
    Existing entity has been suspended.

  - ### ENTITY_ACTIVATED

    public static final FlowableEngineEventType ENTITY_ACTIVATED
    Existing entity has been activated.

  - ### TIMER_SCHEDULED

    public static final FlowableEngineEventType TIMER_SCHEDULED
    A Timer has been scheduled.

  - ### TIMER_FIRED

    public static final FlowableEngineEventType TIMER_FIRED
    Timer has been fired successfully.

  - ### JOB_CANCELED

    public static final FlowableEngineEventType JOB_CANCELED
    Timer has been cancelled (e.g. user task on which it was bounded has been completed earlier than expected)

  - ### JOB_EXECUTION_SUCCESS

    public static final FlowableEngineEventType JOB_EXECUTION_SUCCESS
    A job has been successfully executed.

  - ### JOB_EXECUTION_FAILURE

    public static final FlowableEngineEventType JOB_EXECUTION_FAILURE
    A job has been executed, but failed. Event should be an instance of a ExceptionEvent.

  - ### JOB_RETRIES_DECREMENTED

    public static final FlowableEngineEventType JOB_RETRIES_DECREMENTED
    The retry-count on a job has been decremented.

  - ### JOB_REJECTED

    public static final FlowableEngineEventType JOB_REJECTED
    A job has been rejected by the async executor. This most likely means the queue is full.

  - ### JOB_RESCHEDULED

    public static final FlowableEngineEventType JOB_RESCHEDULED
    The job has been rescheduled.

  - ### JOB_MOVED_TO_DEADLETTER

    public static final FlowableEngineEventType JOB_MOVED_TO_DEADLETTER
    A job has been moved to become a deadletter job. This typically means that the number of retries have been exhausted.

  - ### CUSTOM

    public static final FlowableEngineEventType CUSTOM
    An event type to be used by custom events. These types of events are never thrown by the engine itself, only be an external API call to dispatch an event.

  - ### ENGINE_CREATED

    public static final FlowableEngineEventType ENGINE_CREATED
    The process-engine that dispatched this event has been created and is ready for use.

  - ### ENGINE_CLOSED

    public static final FlowableEngineEventType ENGINE_CLOSED
    The process-engine that dispatched this event has been closed and cannot be used anymore.

  - ### ACTIVITY_STARTED

    public static final FlowableEngineEventType ACTIVITY_STARTED
    An activity is starting to execute. This event is dispatched right before an activity is executed.

  - ### ACTIVITY_COMPLETED

    public static final FlowableEngineEventType ACTIVITY_COMPLETED
    An activity has been completed successfully.

  - ### ACTIVITY_CANCELLED

    public static final FlowableEngineEventType ACTIVITY_CANCELLED
    An activity has been cancelled because of boundary event.

  - ### MULTI_INSTANCE_ACTIVITY_STARTED

    public static final FlowableEngineEventType MULTI_INSTANCE_ACTIVITY_STARTED
    A multi-instance activity is starting to execute. This event is dispatched right before an activity is executed.

  - ### MULTI_INSTANCE_ACTIVITY_COMPLETED

    public static final FlowableEngineEventType MULTI_INSTANCE_ACTIVITY_COMPLETED
    A multi-instance activity has been completed successfully.

  - ### MULTI_INSTANCE_ACTIVITY_COMPLETED_WITH_CONDITION

    public static final FlowableEngineEventType MULTI_INSTANCE_ACTIVITY_COMPLETED_WITH_CONDITION
    A multi-instance activity has met its condition and completed successfully.

  - ### MULTI_INSTANCE_ACTIVITY_CANCELLED

    public static final FlowableEngineEventType MULTI_INSTANCE_ACTIVITY_CANCELLED
    A multi-instance activity has been cancelled.

  - ### ACTIVITY_SIGNAL_WAITING

    public static final FlowableEngineEventType ACTIVITY_SIGNAL_WAITING
    A boundary, intermediate, or subprocess start signal catching event has started.

  - ### ACTIVITY_SIGNALED

    public static final FlowableEngineEventType ACTIVITY_SIGNALED
    An activity has received a signal. Dispatched after the activity has responded to the signal.

  - ### ACTIVITY_COMPENSATE

    public static final FlowableEngineEventType ACTIVITY_COMPENSATE
    An activity is about to be executed as a compensation for another activity. The event targets the activity that is about to be executed for compensation.

  - ### ACTIVITY_CONDITIONAL_WAITING

    public static final FlowableEngineEventType ACTIVITY_CONDITIONAL_WAITING
    A boundary, intermediate, or subprocess start conditional catching event has started.

  - ### ACTIVITY_CONDITIONAL_RECEIVED

    public static final FlowableEngineEventType ACTIVITY_CONDITIONAL_RECEIVED
    An activity has received a conditional event. Dispatched before the actual conditional event has been received by the activity. This event will be either followed by a #ACTIVITY_SIGNALLED event or #ACTIVITY_COMPLETED for the involved activity, if the error was delivered successfully.

  - ### ACTIVITY_ESCALATION_WAITING

    public static final FlowableEngineEventType ACTIVITY_ESCALATION_WAITING
    A boundary, intermediate, or subprocess start escalation catching event has started.

  - ### ACTIVITY_ESCALATION_RECEIVED

    public static final FlowableEngineEventType ACTIVITY_ESCALATION_RECEIVED
    An activity has received an escalation event. Dispatched before the actual escalation has been received by the activity. This event will be either followed by a #ACTIVITY_SIGNALLED event or #ACTIVITY_COMPLETED for the involved activity, if the error was delivered successfully.

  - ### ACTIVITY_MESSAGE_WAITING

    public static final FlowableEngineEventType ACTIVITY_MESSAGE_WAITING
    A boundary, intermediate, or subprocess start message catching event has started.

  - ### ACTIVITY_MESSAGE_RECEIVED

    public static final FlowableEngineEventType ACTIVITY_MESSAGE_RECEIVED
    An activity has received a message event. Dispatched before the actual message has been received by the activity. This event will be either followed by a #ACTIVITY_SIGNALLED event or #ACTIVITY_COMPLETED for the involved activity, if the message was delivered successfully.

  - ### ACTIVITY_MESSAGE_CANCELLED

    public static final FlowableEngineEventType ACTIVITY_MESSAGE_CANCELLED
    A boundary, intermediate, or subprocess start message catching event has been cancelled.

  - ### ACTIVITY_ERROR_RECEIVED

    public static final FlowableEngineEventType ACTIVITY_ERROR_RECEIVED
    An activity has received an error event. Dispatched before the actual error has been received by the activity. This event will be either followed by a #ACTIVITY_SIGNALLED event or #ACTIVITY_COMPLETED for the involved activity, if the error was delivered successfully.

  - ### HISTORIC_ACTIVITY_INSTANCE_CREATED

    public static final FlowableEngineEventType HISTORIC_ACTIVITY_INSTANCE_CREATED
    A event dispatched when a HistoricActivityInstance is created. This is a specialized version of the `ENTITY_CREATED` and `ENTITY_INITIALIZED` event, with the same use case as the `ACTIVITY_STARTED`, but containing slightly different data. Note this will be an FlowableEngineEventType, where the entity is the HistoricActivityInstance. Note that history (minimum level ACTIVITY) must be enabled to receive this event.

  - ### HISTORIC_ACTIVITY_INSTANCE_ENDED

    public static final FlowableEngineEventType HISTORIC_ACTIVITY_INSTANCE_ENDED
    A event dispatched when a HistoricActivityInstance is marked as ended. his is a specialized version of the `ENTITY_UPDATED` event, with the same use case as the `ACTIVITY_COMPLETED`, but containing slightly different data (e.g. the end time, the duration, etc.). Note that history (minimum level ACTIVITY) must be enabled to receive this event.

  - ### SEQUENCEFLOW_TAKEN

    public static final FlowableEngineEventType SEQUENCEFLOW_TAKEN
    Indicates the engine has taken (ie. followed) a sequenceflow from a source activity to a target activity.

  - ### VARIABLE_CREATED

    public static final FlowableEngineEventType VARIABLE_CREATED
    A new variable has been created.

  - ### VARIABLE_UPDATED

    public static final FlowableEngineEventType VARIABLE_UPDATED
    An existing variable has been updated.

  - ### VARIABLE_DELETED

    public static final FlowableEngineEventType VARIABLE_DELETED
    An existing variable has been deleted.

  - ### TASK_CREATED

    public static final FlowableEngineEventType TASK_CREATED
    A task has been created. This is thrown when task is fully initialized (before TaskListener.EVENTNAME_CREATE).

  - ### TASK_ASSIGNED

    public static final FlowableEngineEventType TASK_ASSIGNED
    A task as been assigned. This is thrown alongside with an #ENTITY_UPDATED event.

  - ### TASK_COMPLETED

    public static final FlowableEngineEventType TASK_COMPLETED
    A task has been completed. Dispatched before the task entity is deleted ( #ENTITY_DELETED). If the task is part of a process, this event is dispatched before the process moves on, as a result of the task completion. In that case, a #ACTIVITY_COMPLETED will be dispatched after an event of this type for the activity corresponding to the task.

  - ### TASK_OWNER_CHANGED

    public static final FlowableEngineEventType TASK_OWNER_CHANGED
    A task owner has been changed. This is thrown alongside with an #ENTITY_UPDATED event.

  - ### TASK_PRIORITY_CHANGED

    public static final FlowableEngineEventType TASK_PRIORITY_CHANGED
    A task priority has been changed. This is thrown alongside with an #ENTITY_UPDATED event.

  - ### TASK_DUEDATE_CHANGED

    public static final FlowableEngineEventType TASK_DUEDATE_CHANGED
    A task dueDate has been changed. This is thrown alongside with an #ENTITY_UPDATED event.

  - ### TASK_NAME_CHANGED

    public static final FlowableEngineEventType TASK_NAME_CHANGED
    A task name has been changed. This is thrown alongside with an #ENTITY_UPDATED event.

  - ### PROCESS_CREATED

    public static final FlowableEngineEventType PROCESS_CREATED
    A process instance has been created. All basic properties have been set, but variables not yet.

  - ### PROCESS_STARTED

    public static final FlowableEngineEventType PROCESS_STARTED
    A process instance has been started. Dispatched when starting a process instance previously created. The event PROCESS_STARTED is dispatched after the associated event ENTITY_INITIALIZED and after the variables have been set.

  - ### PROCESS_COMPLETED

    public static final FlowableEngineEventType PROCESS_COMPLETED
    A process has been completed. Dispatched after the last activity is ACTIVITY_COMPLETED. Process is completed when it reaches state in which process instance does not have any transition to take.

  - ### PROCESS_COMPLETED_WITH_TERMINATE_END_EVENT

    public static final FlowableEngineEventType PROCESS_COMPLETED_WITH_TERMINATE_END_EVENT
    A process has been completed with a terminate end event.

  - ### PROCESS_COMPLETED_WITH_ERROR_END_EVENT

    public static final FlowableEngineEventType PROCESS_COMPLETED_WITH_ERROR_END_EVENT
    A process has been completed with an error end event.

  - ### PROCESS_COMPLETED_WITH_ESCALATION_END_EVENT

    public static final FlowableEngineEventType PROCESS_COMPLETED_WITH_ESCALATION_END_EVENT
    A process has been completed with an escalation end event.

  - ### PROCESS_CANCELLED

    public static final FlowableEngineEventType PROCESS_CANCELLED
    A process has been cancelled. Dispatched when process instance is deleted by org.flowable.engine.impl.RuntimeServiceImpl#deleteProcessInstance(java.lang.String, java.lang.String), before DB delete.

  - ### HISTORIC_PROCESS_INSTANCE_CREATED

    public static final FlowableEngineEventType HISTORIC_PROCESS_INSTANCE_CREATED
    A event dispatched when a HistoricProcessInstance is created. This is a specialized version of the `ENTITY_CREATED` and `ENTITY_INITIALIZED` event, with the same use case as the `PROCESS_STARTED`, but containing slightly different data (e.g. the start time, the start user id, etc.). Note this will be an FlowableEngineEventType, where the entity is the HistoricProcessInstance. Note that history (minimum level ACTIVITY) must be enabled to receive this event.

  - ### HISTORIC_PROCESS_INSTANCE_ENDED

    public static final FlowableEngineEventType HISTORIC_PROCESS_INSTANCE_ENDED
    A event dispatched when a HistoricProcessInstance is marked as ended. his is a specialized version of the `ENTITY_UPDATED` event, with the same use case as the `PROCESS_COMPLETED`, but containing slightly different data (e.g. the end time, the duration, etc.). Note that history (minimum level ACTIVITY) must be enabled to receive this event.

  - ### CASE_STARTED

    public static final FlowableEngineEventType CASE_STARTED
    A case instance has been started. Dispatched when starting a case instance previously created. The event is dispatched after the associated `ENTITY_INITIALIZED` and the variables have been set.

  - ### CASE_ENDED

    public static final FlowableEngineEventType CASE_ENDED
    A case instance has been ended by either completing or terminating it. The event is being dispatched after the lifecycle listeners have been invoked, but before the end state will be set on the case instance.

  - ### STAGE_STARTED

    public static final FlowableEngineEventType STAGE_STARTED
    A stage instance (plan item) has been started (went into active state, not to be confused with the creation of the stage plan item). The event is being dispatched after the lifecycle listeners have been invoked.

  - ### STAGE_ENDED

    public static final FlowableEngineEventType STAGE_ENDED
    A stage instance (plan item) has been ended (either through completion, manual termination or an exit). The event is being dispatched after the lifecycle listeners have been invoked.

  - ### CHANGE_TENANT_ID

    public static final FlowableEngineEventType CHANGE_TENANT_ID
    A change tenant id was executed.

- ## Field Details

  - ### EMPTY_ARRAY

    public static final FlowableEngineEventType[] EMPTY_ARRAY

- ## Method Details

  - ### values

    public static FlowableEngineEventType[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static FlowableEngineEventType valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getTypesFromString

    public static FlowableEngineEventType[] getTypesFromString(String string)
    Parameters:
      `string` - the string containing a comma-separated list of event-type names
    Returns:
      an array of FlowableEngineEventType based on the given string.
    Throws:
      `FlowableIllegalArgumentException` - when one of the given string is not a valid type name